/* Problem URL: https://codeforces.com/contest/2114/problem/E */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n;
        cin >> n;

        vl fds(n);
        cin >> fds;

        vvi graph(n);
        rep(i, n - 1) {
            int a, b;
            cin >> a >> b;
            a--, b--;

            graph[a].push_back(b);
            graph[b].push_back(a);
        }

        vvl dp(n, vl(2, 0));

        vi parent(n);
        parent[0] = -1;

        function<void(int, int)> make_p = [&](int i, int p) {
            parent[i] = p;

            for (auto j : graph[i]) {
                if (j == p) {
                    continue;
                }

                make_p(j, i);
            }
        };

        make_p(0, -1);
        vl ans(n);

        V<bool> vis(n, false);

        function<void(int)> calc = [&](int i) {
            if (i == 0) {
                ans[i] = fds[i];
                dp[i][0] = fds[i];
                dp[i][1] = -fds[i];
                return;
            }

            if (vis[i]) {
                return;
            }

            vis[i] = true;
            dp[i][0] = fds[i];
            dp[i][1] = -fds[i];

            calc(parent[i]);

            rmax(dp[i][0], dp[i][0] + dp[parent[i]][1]);
            rmax(dp[i][1], dp[i][1] + dp[parent[i]][0]);

            ans[i] = dp[i][0];
        };

        rep(i, n) {
            calc(i);
        }

        cout << ans;
    }
}
